include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext WaitVdp
ext BackgroundPattern
ext dotOffset_
ext pStage_, StageMap_, topRow_, yMod_
ext DrawBlocks_

VisibleFloorCount equ (WindowHeight+FloorHeight-1)/FloorHeight+1
FloorHeight equ 4
ColumnCount equ 16
MapWidth equ ColumnCount/4

CellType_Space equ 0
CellType_Ladder equ 1
CellType_Wall equ 2
CellType_Hole equ 3

pSource equ ZW0
wVram equ ZW1
count equ ZB0
yPos equ ZB1
mapHeight equ ZB2
currentRow equ ZB3
fCount equ ZB4
cCount equ ZB5
bCount equ ZB6

zseg
upperByte:
    defb 0
middleByte:
    defb 0
lowerByte:
    defb 0


dseg
GeneratorRegValue: public GeneratorRegValue
    defb 0
NameRegValue: public NameRegValue
    defb 0


; void UpdateBackgroundChars();
BackgroundPG1 equ $4000+Vram_PatternGenerator+Char_Background*CharHeight
BackgroundPG2 equ $4000+Vram_PatternGenerator2+Char_Background*CharHeight
cseg
UpdateBackgroundChars_: public UpdateBackgroundChars_
    pha
        lda GeneratorRegValue
        if eq
            ldy #low BackgroundPG2 | ldx #high BackgroundPG2
        else
            ldy #low BackgroundPG1 | ldx #high BackgroundPG1
        endif
        sei
            sty VdpWritePort+1
            stx VdpWritePort+1

            lda #low BackgroundPattern | sta <pSource
            lda #high BackgroundPattern | sta <pSource+1
            lda #Char_Alter-Char_BackGround | sta <count
            do
                lda #7
                sec|sbc dotOffset_
                tay
                ldx #8
                do
                    lda (<pSource),y | iny
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
                lda <pSource | clc|adc #15 | sta <pSource
                lda <pSource+1 | adc #0 | sta <pSource+1
                dec<count
            while ne | wend
        cli
    pla
rts


; void SwitchChars();
cseg
SwitchChars_: public SwitchChars_
    pha
        lda GeneratorRegValue
        eor #1
        sta GeneratorRegValue
        sta VdpWritePort+1
        lda #$80+4
        sta VdpWritePort+1
    pla
rts


; void MapToVram();
VramTop05 equ VramTop-$400
VramTop06 equ VramTop
cseg
Repeat: public Repeat
    sta <count
    do
        lda <yPos
        cmp #WindowHeight
        if cc
            sei
                lda <wVram | sta VdpWritePort+1
                lda <wVram+1 | sta VdpWritePort+1
                tya | sta VdpWritePort | jsr WaitVdp
                txa | sta VdpWritePort | jsr WaitVdp
            cli
        endif
        inc <yPos
        lda <wVram | clc|adc #WindowWidth | sta <wVram
        lda <wVram+1 | adc #0 | sta <wVram+1
        dec <count
    while ne | wend
rts
MapToVram_: public MapToVram_
    pha
        lda NameRegValue
        cmp #$06
        if eq
            ldy #low VramTop05 | ldx #high VramTop05 or $40
            lda #$05
        else
            ldy #low VramTop06 | ldx #high VramTop06 or $40
            lda #$06
        endif
        sta NameRegValue
        sty <wVram | stx <wVram+1

        lda pStage_ | sta <pSource
        lda pStage_+1 | sta <pSource+1
        ldy #0 | lda (<pSource),y | sec|sbc #1 | sta <mapHeight

        lda topRow_ | sta <currentRow
        if pl
            asl a | asl a
            clc|adc #low(StageMap_-MapWidth) | sta <pSource
            lda #high(StageMap_-MapWidth) | adc #0 | sta <pSource+1
        else
            lda #low(StageMap_-MapWidth*2) | sta <pSource
            lda #high(StageMap_-MapWidth*2) | sta <pSource+1
        endif

        lda #0 | sec|sbc yMod_ | sta <yPos
        tax
        do
        while mi
            lda <wVram | sec|sbc #WindowWidth | sta <wVram
            lda <wVram+1 | sbc #0 | sta <wVram+1
            inx
        wend

        lda #VisibleFloorCount | sta <fCount
        do
            lda #MapWidth | sta <cCount
            do
                lda <currentRow
                if pl
                    if eq
                        lda #0
                    else
                        ldy #0 | lda (<pSource),y
                    endif
                    sta <upperByte
                    ldy #MapWidth | lda (<pSource),y | sta <middleByte

                    lda <currentRow
                    cmp <mapHeight
                    if cc
                        ldy #MapWidth*2 | lda (<pSource),y
                    else
                        lda #0
                    endif
                    sta <lowerByte
                else
                    lda #$ff | sta <upperByte
                    lda #0 | sta <middleByte
                    ldy #MapWidth*2 | lda (<pSource),y | sta <lowerByte
                endif
                lda <pSource | clc|adc #1 | sta <pSource
                lda <pSource+1 | adc #0 | sta <pSource+1

                lda #4 | sta <bCount
                do
                    lda <middleByte
                    and #3
                    if eq
                        lda <upperByte
                        and #3
                        cmp #CellType_Hole
                        if eq
                            ldy #Char_Space | ldx #Char_Space
                        else
                            ldy #Char_Floor_Space | ldx #Char_Floor_Space
                        endif
                        lda #1 | jsr Repeat

                        lda <lowerByte
                        and #3
                        cmp #CellType_Ladder
                        if eq
                            ldy #Char_Space_LeftLadder | ldx #Char_Space_RightLadder
                            lda #1 | jsr Repeat
                            ldy #Char_LeftLadder_LeftLadder | ldx #Char_RightLadder_RightLadder
                            lda #2 | jsr Repeat
                            jmp next
                        endif
                        cmp #CellType_Wall
                        if eq
                            ldy #Char_Space | ldx #Char_Space
                            lda #2 | jsr Repeat
                            ldy #Char_Space_Wall | ldx #Char_Space_Floor
                            lda #1 | jsr Repeat
                            jmp next
                        endif
                        ldy #Char_Space | ldx #Char_Space
                        lda #2 | jsr Repeat
                        ldy #Char_Space_Floor | ldx #Char_Space_Floor
                        lda #1 | jsr Repeat
                        jmp next
                    endif
                    cmp #CellType_Ladder ; middleByte
                    if eq
                        ldy #Char_LeftLadder_LeftLadder | ldx #Char_RightLadder_RightLadder
                        lda #3 | jsr Repeat
                        lda <lowerByte
                        and #3
                        cmp #CellType_Ladder
                        if eq
                            ldy #Char_LeftLadder_LeftLadder | ldx #Char_RightLadder_RightLadder
                            lda #1 | jsr Repeat
                            jmp next
                        endif
                        cmp #CellType_Wall ; lowerByte
                        if eq
                            ldy #Char_LeftLadder_Wall | ldx #Char_RightLadder_Floor
                        else
                            ldy #Char_LeftLadder_Floor | ldx #Char_RightLadder_Floor
                        endif
                        lda #1 | jsr Repeat
                        jmp next
                    endif
                    cmp #CellType_Wall ; middleByte
                    if eq
                        ldy #Char_Wall_Wall | ldx #Char_Floor_Space
                        lda #1 | jsr Repeat
                        ldy #Char_Wall_Wall | ldx #Char_Space
                        lda #2 | jsr Repeat
                        lda <lowerByte
                        and #3
                        cmp #CellType_Wall
                        if eq
                            ldy #Char_Wall_Wall | ldx #Char_Space_Floor
                        else
                            ldy #Char_Wall_Floor | ldx #Char_Space_Floor
                        endif
                        lda #1 | jsr Repeat
                        jmp next
                    endif
                    lda <upperByte
                    and #3
                    cmp #CellType_Hole
                    if eq
                        ldy #Char_Space | ldx #Char_Space
                    else
                        ldy #Char_Floor_Space | ldx #Char_Floor_Space
                    endif
                    lda #1 | jsr Repeat
                    ldy #Char_Space | ldx #Char_Space
                    lda #3 | jsr Repeat
                    next:
                    lda <wVram | clc|adc #low(-WindowWidth*4+2) | sta <wVram
                    lda <wVram+1 | adc #high(-WindowWidth*4+2) | sta <wVram+1
                    lsr <upperByte | lsr <upperByte
                    lsr <middleByte | lsr <middleByte
                    lsr <lowerByte | lsr <lowerByte
                    lda <yPos | sec|sbc #4 | sta <yPos
                    dec <bCount
                while ne | wend
                dec <cCount
            while ne | wend
            lda <wVram | clc|adc #low(WindowWidth*(4-1)) | sta <wVram
            lda <wVram+1 | adc #high(WindowWidth*(4-1)) | sta <wVram+1
            inc <currentRow
            lda <yPos | clc|adc #4 | sta <yPos
            dec <fCount
        while ne | wend

        jsr DrawBlocks_
        lda NameRegValue | sta VdpWritePort+1
        lda #$80+2 | sta VdpWritePort+1
    pla
rts